ynh-hotspot 17 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169170171172173174175176177178179180181182183184185186187188189190191192193194195196197198199200201202203204205206207208209210211212213214215216217218219220221222223224225226227228229230231232233234235236237238239240241242243244245246247248249250251252253254255256257258259260261262263264265266267268269270271272273274275276277278279280281282283284285286287288289290291292293294295296297298299300301302303304305306307308309310311312313314315316317318319320321322323324325326327328329330331332333334335336337338339340341342343344345346347348349350351352353354355356357358359360361362363364365366367368369370371372373374375376377378379380381382383384385386387388389390391392393394395396397398399400401402403404405406407408409410411412413414415416417418419420421422423424425426427428429430431432433434435436437438439440441442443444445446447448449450451452453454455456457458459460461462463464465466467468469470471472473474475476477478479480481482483484485486487488489490491492493494495496497498499500501502503504505506507508509510511512513514515516517518519520521522523524525526527528529530531532533534535536537538539540541542543544545546547548549550551552553554555556557558559560561562563564565566567568
  1. #!/bin/bash
  2. #
  3. # Wifi Hotspot app for YunoHost
  4. # Copyright (C) 2015 Julien Vaubourg <julien@vaubourg.com>
  5. # Contribute at https://github.com/labriqueinternet/hotspot_ynh
  6. #
  7. # This program is free software: you can redistribute it and/or modify
  8. # it under the terms of the GNU Affero General Public License as published by
  9. # the Free Software Foundation, either version 3 of the License, or
  10. # (at your option) any later version.
  11. #
  12. # This program is distributed in the hope that it will be useful,
  13. # but WITHOUT ANY WARRANTY; without even the implied warranty of
  14. # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
  15. # GNU Affero General Public License for more details.
  16. #
  17. # You should have received a copy of the GNU Affero General Public License
  18. # along with this program. If not, see <http://www.gnu.org/licenses/>.
  19. # Functions
  20. ## State functions
  21. has_vpnclient_app() {
  22. [ -e /tmp/.ynh-vpnclient-started ]
  23. }
  24. has_ip6delegatedprefix() {
  25. local i=${1}
  26. [[ -n "${ip6_net[${i}]}" ]] && [[ "${ip6_net[${i}]}" != "none" ]]
  27. }
  28. ip6addrfromdelegatedprefix() {
  29. local i=${1}
  30. echo "${ip6_net[${i}]}${i}001"
  31. }
  32. is_nat_set() {
  33. local gateway_interface=${1}
  34. iptables -w -nvt nat -L POSTROUTING | grep MASQUERADE | grep -q "${gateway_interface}"
  35. }
  36. is_ip4nataddr_set() {
  37. local i=${1}
  38. local dev=$(devfromid "${i}")
  39. ip address show dev "${dev}" 2>/dev/null | grep -q "${ip4_nat_prefix[${i}]}.1/24"
  40. }
  41. is_ip6addr_set() {
  42. local i=${1}
  43. local dev=$(devfromid "${i}")
  44. ip address show dev "${dev}" 2>/dev/null | grep -q "$(ip6addrfromdelegatedprefix $i)/64"
  45. }
  46. is_ip6firewall_set() {
  47. local i=${1}
  48. local dev=$(devfromid "${i}")
  49. ip6tables -w -nvL FORWARD | grep DROP | grep -q "${dev}"
  50. }
  51. is_forwarding_set() {
  52. local ip6=$(sysctl net.ipv6.conf.all.forwarding | awk '{ print $NF; }')
  53. local ip4=$(sysctl net.ipv4.conf.all.forwarding | awk '{ print $NF; }')
  54. [ "${ip6}" -eq 1 ] && [ "${ip4}" -eq 1 ]
  55. }
  56. is_dhcpd6_running() {
  57. local i=${1}
  58. ps aux | grep "dhcpdv6-ssid${i}" | grep -qv grep
  59. }
  60. is_dhcpd4_running() {
  61. local i=${1}
  62. ps aux | grep "dhcpdv4-ssid${i}" | grep -qv grep
  63. }
  64. is_hostapd_running() {
  65. systemctl is-active hostapd &>/dev/null
  66. }
  67. is_running() {
  68. for i in $(seq 0 $((${multissid} - 1))); do
  69. (has_ip6delegatedprefix ${i} && is_ip6addr_set ${i} \
  70. && ([ "${ip6_firewall[${i}]}" -eq 1 ] && is_ip6firewall_set ${i} || [ "${ip6_firewall[${i}]}" -eq 0 ]) \
  71. && is_dhcpd6_running ${i} || ! has_ip6delegatedprefix ${i}) \
  72. && is_ip4nataddr_set ${i} && is_dhcpd4_running ${i}
  73. if [ ! $? -eq 0 ]; then
  74. return 1
  75. fi
  76. done
  77. is_hostapd_running && is_forwarding_set && ([ -z "${new_gateway_interface}" ] || is_nat_set "${new_gateway_interface}")
  78. }
  79. ## Setters
  80. set_nat() {
  81. local gateway_interface=${1}
  82. iptables -w -t nat -A POSTROUTING -o "${gateway_interface}" -j MASQUERADE
  83. }
  84. set_ipaddr() {
  85. local i=${1}
  86. local dev=$(devfromid "${i}")
  87. if ! is_ip4nataddr_set ${i}; then
  88. echo "hotspot${i}: Set IPv4 NAT address"
  89. ip address add "${ip4_nat_prefix[${i}]}.1/24" dev "${dev}"
  90. fi
  91. if has_ip6delegatedprefix ${i} && ! is_ip6addr_set ${i}; then
  92. echo "hotspot${i}: Set IPv6 address"
  93. ip address delete "$(ip6addrfromdelegatedprefix $i)/64" dev tun0 &>/dev/null
  94. ip address add "$(ip6addrfromdelegatedprefix $i)/64" dev "${dev}"
  95. fi
  96. }
  97. set_ipfirewall() {
  98. local i=${1}
  99. local dev=$(devfromid "${i}")
  100. # Set ipv6 firewalling
  101. if has_ip6delegatedprefix ${i} && [ "${ip6_firewall[${i}]}" -eq 1 ] && ! is_ip6firewall_set ${i}; then
  102. echo "hotspot${i}: Set IPv6 firewalling"
  103. ip6tables -w -A FORWARD -i "${dev}" -j ACCEPT
  104. ip6tables -w -A FORWARD -o "${dev}" -m conntrack --ctstate ESTABLISHED,RELATED -j ACCEPT
  105. ip6tables -w -A FORWARD -o "${dev}" -j DROP
  106. fi
  107. }
  108. set_forwarding() {
  109. sysctl -w net.ipv6.conf.all.forwarding=1 >/dev/null
  110. sysctl -w net.ipv4.conf.all.forwarding=1 >/dev/null
  111. }
  112. start_dhcpd() {
  113. local i=${1}
  114. local dev=$(devfromid "${i}")
  115. # Run DHCPv4 server
  116. if ! is_dhcpd4_running ${i}; then
  117. echo "hotspot${i}: Start the DHCPv4 server (dnsmasq)"
  118. cp /etc/dnsmasq.dhcpd/dhcpdv4{.conf.tpl,-ssid${i}.conf}
  119. sed "s|__WIFI_DEVICE__|${dev}|g" -i /etc/dnsmasq.dhcpd/dhcpdv4-ssid${i}.conf
  120. sed "s|__IP4_DNS__|${ip4_dns[${i}]}|g" -i /etc/dnsmasq.dhcpd/dhcpdv4-ssid${i}.conf
  121. sed "s|__IP4_NAT_PREFIX__|${ip4_nat_prefix[${i}]}|g" -i /etc/dnsmasq.dhcpd/dhcpdv4-ssid${i}.conf
  122. dnsmasq -C /etc/dnsmasq.dhcpd/dhcpdv4-ssid${i}.conf -p0
  123. fi
  124. # Run DHCPv6 server
  125. if has_ip6delegatedprefix ${i} && ! is_dhcpd6_running ${i}; then
  126. echo "hotspot${i}: Start the NDP and DHCPv6 server (dnsmasq)"
  127. cp /etc/dnsmasq.dhcpd/dhcpdv6{.conf.tpl,-ssid${i}.conf}
  128. sed "s|__WIFI_DEVICE__|${dev}|g" -i /etc/dnsmasq.dhcpd/dhcpdv6-ssid${i}.conf
  129. sed "s|__IP6_DNS__|${ip6_dns[${i}]}|g" -i /etc/dnsmasq.dhcpd/dhcpdv6-ssid${i}.conf
  130. sed "s|__IP6_NET__|${ip6_net[${i}]}|g" -i /etc/dnsmasq.dhcpd/dhcpdv6-ssid${i}.conf
  131. dnsmasq -C /etc/dnsmasq.dhcpd/dhcpdv6-ssid${i}.conf -p0
  132. fi
  133. }
  134. configure_hostapd() {
  135. local ethaddr=$(ip link show dev "${wifi_device}" | grep link/ether | awk -F: '{ printf "02:%s:%s:%s:%s:00", $2, $3, $4, $5 }')
  136. ip link set addr "${ethaddr}" dev "${wifi_device}"
  137. cp /etc/hostapd/hostapd.base.conf /etc/hostapd/hostapd.conf
  138. sed "s|__WIFI_DEVICE__|${wifi_device}|g" -i /etc/hostapd/hostapd.conf
  139. sed "s|__WIFI_CHANNEL__|${wifi_channel}|g" -i /etc/hostapd/hostapd.conf
  140. sed "s|__N_COMMENT__||g" -i /etc/hostapd/hostapd.conf
  141. for i in $(seq 0 $((${multissid} - 1))); do
  142. [ "${wifi_secure[${i}]}" -eq 1 ] && local sec_comment="" || local sec_comment="#"
  143. [ "${i}" -eq 0 ] && local bss_comment="#" || local bss_comment=""
  144. cp /etc/hostapd/hostapd.accesspoint.conf /etc/hostapd/hostapd.conf.tmp
  145. sed "s|__WIFI_INTERFACE__|hotspot${i}|g" -i /etc/hostapd/hostapd.conf.tmp
  146. sed "s|__WIFI_SSID__|${wifi_ssid[${i}]}|g" -i /etc/hostapd/hostapd.conf.tmp
  147. sed "s|__WIFI_PASSPHRASE__|${wifi_passphrase[${i}]}|g" -i /etc/hostapd/hostapd.conf.tmp
  148. sed "s|__SEC_COMMENT__|${sec_comment}|g" -i /etc/hostapd/hostapd.conf.tmp
  149. sed "s|__BSS_COMMENT__|${bss_comment}|g" -i /etc/hostapd/hostapd.conf.tmp
  150. cat /etc/hostapd/hostapd.conf.tmp >>/etc/hostapd/hostapd.conf
  151. rm /etc/hostapd/hostapd.conf.tmp
  152. done
  153. }
  154. ## Unsetters
  155. unset_nat() {
  156. local gateway_interface=${1}
  157. iptables -w -t nat -D POSTROUTING -o "${gateway_interface}" -j MASQUERADE
  158. }
  159. unset_ipaddr() {
  160. local i=${1}
  161. local dev=$(devfromid "${i}")
  162. if is_ip4nataddr_set ${i}; then
  163. echo "hotspot${i}: Unset IPv4 NAT address"
  164. ip address delete "${ip4_nat_prefix[${i}]}.1/24" dev "${dev}"
  165. fi
  166. if has_ip6delegatedprefix ${i} && is_ip6addr_set ${i}; then
  167. echo "hotspot${i}: Unset IPv6 address"
  168. ip address delete "$(ip6addrfromdelegatedprefix $i)/64" dev "${dev}"
  169. fi
  170. }
  171. unset_ipfirewall() {
  172. local i=${1}
  173. local dev=$(devfromid "${i}")
  174. if has_ip6delegatedprefix ${i} && [ "${ip6_firewall[${i}]}" -eq 1 ] && is_ip6firewall_set ${i}; then
  175. echo "hotspot${i}: Unset IPv6 firewalling"
  176. ip6tables -w -D FORWARD -i "${dev}" -j ACCEPT
  177. ip6tables -w -D FORWARD -o "${dev}" -m conntrack --ctstate ESTABLISHED,RELATED -j ACCEPT
  178. ip6tables -w -D FORWARD -o "${dev}" -j DROP
  179. fi
  180. }
  181. unset_forwarding() {
  182. sysctl -w net.ipv6.conf.all.forwarding=0 >/dev/null
  183. sysctl -w net.ipv4.conf.all.forwarding=0 >/dev/null
  184. }
  185. stop_dhcpd() {
  186. local i=${1}
  187. if is_dhcpd6_running ${i}; then
  188. echo "hotspot${i}: Stop the NDP and DHCPv6 server (dnsmasq)"
  189. kill $(ps aux | grep 'dhcpdv6-ssid' | grep -v grep | awk '{ print $2 }')
  190. rm -f /etc/dnsmasq.d/dhcpdv6-ssid*.conf
  191. fi
  192. if is_dhcpd4_running ${i}; then
  193. echo "hotspot${i}: Stop the DHCPv4 server (dnsmasq)"
  194. kill $(ps aux | grep 'dhcpdv4-ssid' | grep -v grep | awk '{ print $2 }')
  195. rm -f /etc/dnsmasq.d/dhcpdv4-ssid*.conf
  196. fi
  197. }
  198. stop_dhcpd4() {
  199. :
  200. }
  201. stop_hostapd() {
  202. systemctl stop hostapd
  203. }
  204. ## Tools
  205. ynh_setting_get() {
  206. APP="$1" KEY="$2" python3 - <<EOF
  207. import os, yaml, sys
  208. app = os.environ['APP']
  209. key = os.environ['KEY']
  210. setting_file = "/etc/yunohost/apps/%s/settings.yml" % app
  211. assert os.path.exists(setting_file), "Setting file %s does not exists ?" % setting_file
  212. with open(setting_file) as f:
  213. settings = yaml.safe_load(f)
  214. if key in settings:
  215. print(settings[key])
  216. EOF
  217. }
  218. ynh_setting_set() {
  219. # This is a partial copypasta of the official ynh_app_setting internal helper
  220. # In particular, we do this instead of relying on 'yunohost app setting' for
  221. # performance reasons (it takes a few second to run every yunohost commands)
  222. # and to remove the need for the infamous '--need-lock' option/issue.
  223. APP="$1" KEY="$2" VALUE="${3:-}" python3 - <<EOF
  224. import os, yaml, sys
  225. app = os.environ['APP']
  226. key, value = os.environ['KEY'], os.environ.get('VALUE', None)
  227. setting_file = "/etc/yunohost/apps/%s/settings.yml" % app
  228. assert os.path.exists(setting_file), "Setting file %s does not exists ?" % setting_file
  229. with open(setting_file) as f:
  230. settings = yaml.load(f)
  231. settings[key] = value
  232. with open(setting_file, "w") as f:
  233. yaml.safe_dump(settings, f, default_flow_style=False)
  234. EOF
  235. }
  236. devfromid() {
  237. local i=${1}
  238. if [ "${i}" -eq 0 ]; then
  239. echo "${wifi_device}"
  240. else
  241. echo "hotspot${i}"
  242. fi
  243. }
  244. if [ "$1" != restart ]; then
  245. # Variables
  246. echo -n "Retrieving Yunohost settings... "
  247. service_enabled=$(systemctl is-enabled ynh-hotspot)
  248. wifi_device=$(ynh_setting_get hotspot wifi_device)
  249. wifi_channel=$(ynh_setting_get hotspot wifi_channel)
  250. multissid=$(ynh_setting_get hotspot multissid)
  251. IFS='|' read -a wifi_ssid <<<"$(ynh_setting_get hotspot wifi_ssid)"
  252. IFS='|' read -a wifi_secure <<<"$(ynh_setting_get hotspot wifi_secure)"
  253. IFS='|' read -a wifi_passphrase <<<"$(ynh_setting_get hotspot wifi_passphrase)"
  254. IFS='|' read -a ip6_firewall <<<"$(ynh_setting_get hotspot ip6_firewall)"
  255. IFS='|' read -a ip6_net <<<"$(ynh_setting_get hotspot ip6_net)"
  256. IFS='|' read -a dns <<<"$(ynh_setting_get hotspot dns)"
  257. IFS='|' read -a ip4_nat_prefix <<<"$(ynh_setting_get hotspot ip4_nat_prefix)"
  258. for i in $(seq 0 $((${multissid} - 1))); do
  259. ip6_dns[${i}]=""
  260. ip4_dns[${i}]=""
  261. for ip in $(echo "${dns[${i}]}" | tr ',' ' '); do
  262. if [[ "$ip" == *":"* ]]; then
  263. ip6_dns[${i}]+="[$ip],"
  264. else
  265. ip4_dns[${i}]+="$ip,"
  266. fi
  267. done
  268. # Remove trailing ,
  269. ip6_dns[${i}]="${ip6_dns[${i}]%%,}"
  270. ip4_dns[${i}]="${ip4_dns[${i}]%%,}"
  271. done
  272. old_gateway_interface=$(ynh_setting_get hotspot gateway_interface)
  273. new_gateway_interface=$(ip route get 1.2.3.4 | awk '{ print $5; }')
  274. # Switch the NAT interface if there is a VPN
  275. ip link show dev tun0 &>/dev/null
  276. if [ "$?" -eq 0 ]; then
  277. new_gateway_interface=tun0
  278. fi
  279. echo "OK"
  280. fi
  281. # Script
  282. case "$1" in
  283. start)
  284. if is_running; then
  285. echo "Already started"
  286. exit 0
  287. elif [ "${service_enabled}" != "enabled" ]; then
  288. echo "Not starting because hotspod service is disabled"
  289. exit 1
  290. fi
  291. if [ -z "${wifi_device}" ]; then
  292. echo "[FAIL] No wifi device selected. Make sure your wifi antenna is plugged-in / available and select it in the Hotspot admin"
  293. exit 1
  294. fi
  295. echo "[hotspot] Starting..."
  296. touch /tmp/.ynh-hotspot-started
  297. # Check old state of the ipv4 NAT settings
  298. if [ -n "${old_gateway_interface}" ] && [ "${new_gateway_interface}" != "${old_gateway_interface}" ] && is_nat_set "${old_gateway_interface}"; then
  299. unset_nat "${old_gateway_interface}"
  300. fi
  301. # Set ipv4 NAT
  302. if [ -n "${new_gateway_interface}" ] && ! is_nat_set "${new_gateway_interface}"; then
  303. echo "Set NAT"
  304. set_nat "${new_gateway_interface}"
  305. fi
  306. # Set forwarding for ipv6 and ipv4
  307. echo "Set forwarding"
  308. set_forwarding
  309. # Run hostapd
  310. if ! is_hostapd_running; then
  311. echo "Configuring hostapd"
  312. configure_hostapd
  313. echo "Starting hostapd..."
  314. if ! systemctl start hostapd; then
  315. journalctl -u hostapd -n 100 --no-hostname --no-pager
  316. exit 1
  317. fi
  318. sleep 1
  319. # On single SSID, the hotspot interface will be wlan0 (or similar)
  320. # in multissid, we additionally want to make sure that at least hotspot1 started
  321. if [ "${multissid}" -gt 1 ]; then
  322. i=0
  323. while ! ip link show dev "hotspot1" &>/dev/null; do
  324. sleep 1
  325. if [ ${i} -gt 20 ]; then
  326. echo "Failed to see hotspot interface showing up in 'ip a'"
  327. stop_hostapd
  328. exit 1
  329. fi
  330. i=$(($i + 1))
  331. done
  332. fi
  333. fi
  334. # For each registred ssid
  335. for i in $(seq 0 $((${multissid} - 1))); do
  336. set_ipaddr ${i}
  337. set_ipfirewall ${i}
  338. start_dhcpd ${i}
  339. done
  340. # Update dynamic settings
  341. ynh_setting_set hotspot gateway_interface "${new_gateway_interface}"
  342. ;;
  343. stop)
  344. echo "[hotspot] Stopping..."
  345. rm -f /tmp/.ynh-hotspot-started
  346. if [ -n "${old_gateway_interface}" ] && is_nat_set "${old_gateway_interface}"; then
  347. echo "Unset NAT"
  348. unset_nat "${old_gateway_interface}"
  349. fi
  350. echo "Unset forwarding"
  351. unset_forwarding
  352. for i in $(seq 0 $((${multissid} - 1))); do
  353. unset_ipaddr ${i}
  354. unset_ipfirewall ${i}
  355. stop_dhcpd ${i}
  356. done
  357. if is_hostapd_running; then
  358. echo "Stop hostapd"
  359. stop_hostapd
  360. fi
  361. # Fix configuration
  362. if has_vpnclient_app; then
  363. ynh-vpnclient start
  364. fi
  365. ;;
  366. restart)
  367. $0 stop
  368. $0 start
  369. ;;
  370. status)
  371. exitcode=0
  372. if [ "${service_enabled}" != "enabled" ]; then
  373. echo "[FAIL] Hotspot Service disabled"
  374. exit 1
  375. fi
  376. if [ -z "${wifi_device}" ]; then
  377. echo "[FAIL] No wifi device selected. Make sure your wifi antenna is plugged-in / available and select it in the Hotspot admin"
  378. exit 1
  379. fi
  380. echo "[INFO] Autodetected internet interface: ${new_gateway_interface} (last start: ${old_gateway_interface})"
  381. if is_nat_set "${new_gateway_interface}"; then
  382. echo "[ OK ] IPv4 NAT set"
  383. else
  384. if [ -z "${new_gateway_interface}" ]; then
  385. echo "[INFO] No IPv4 NAT set (no internet interface)"
  386. else
  387. echo "[FAIL] No IPv4 NAT set"
  388. fi
  389. exitcode=1
  390. fi
  391. if is_forwarding_set; then
  392. echo "[ OK ] IPv6/IPv4 forwarding set"
  393. else
  394. echo "[FAIL] No IPv6/IPv4 forwarding set"
  395. exitcode=1
  396. fi
  397. if is_hostapd_running; then
  398. echo "[ OK ] Hostapd is running"
  399. else
  400. echo "[FAIL] Hostapd is not running"
  401. exitcode=1
  402. fi
  403. for i in $(seq 0 $((${multissid} - 1))); do
  404. if has_ip6delegatedprefix ${i}; then
  405. echo "[INFO] hotspot${i}: IPv6 delegated prefix found"
  406. echo "[INFO] hotspot${i}: IPv6 address computed from the delegated prefix: $(ip6addrfromdelegatedprefix $i)"
  407. if is_ip6addr_set ${i}; then
  408. echo "[ OK ] hotspot${i}: IPv6 address set"
  409. else
  410. echo "[FAIL] hotspot${i}: No IPv6 address set"
  411. exitcode=1
  412. fi
  413. if is_ip6firewall_set ${i}; then
  414. echo "[ OK ] hotspot${i}: IPv6 firewalling set"
  415. else
  416. if [ "${ip6_firewall[${i}]}" -eq 1 ]; then
  417. echo "[FAIL] hotspot${i}: No IPv6 firewalling set"
  418. else
  419. echo "[INFO] hotspot${i}: No IPv6 firewalling set"
  420. fi
  421. exitcode=1
  422. fi
  423. if is_dhcpd6_running ${i}; then
  424. echo "[ OK ] hotspot${i}: NDP and DHCPv6 server (dnsmasq) are running"
  425. else
  426. echo "[FAIL] hotspot${i}: NDP and DHCPv6 server (dnsmasq) are not running"
  427. exitcode=1
  428. fi
  429. else
  430. echo "[INFO] hotspot${i}: No IPv6 delegated prefix found"
  431. fi
  432. if is_dhcpd4_running ${i}; then
  433. echo "[ OK ] hotspot${i}: DHCPv4 server (dnsmasq) is running"
  434. else
  435. echo "[FAIL] hotspot${i}: DHCPv4 (dnsmasq) is not running"
  436. exitcode=1
  437. fi
  438. if is_ip4nataddr_set ${i}; then
  439. echo "[ OK ] hotspot${i}: IPv4 NAT address set"
  440. else
  441. echo "[FAIL] hotspot${i}: No IPv4 NAT address set"
  442. exitcode=1
  443. fi
  444. done
  445. exit ${exitcode}
  446. ;;
  447. *)
  448. echo "Usage: $0 {start|stop|restart|status}"
  449. exit 1
  450. ;;
  451. esac
  452. exit 0